from oslo_middleware.cors import CORS

from oslo_config import cfg
from pecan import make_app, configuration
from magellan.common import config as m_config
from magellan.utils import wsme_utils


def get_pecan_config():
    opts = cfg.CONF.pecan
    cfg_dict = {
        "app": {
            "root": opts.root,
            "modules": opts.modules,
            "debug": opts.debug,
            "auth_enable": opts.auth_enable
        }
    }

    return configuration.conf_from_dict(cfg_dict)


def setup_app(config=None):
    if not config:
        config = get_pecan_config()

    app_conf = dict(config.app)
    m_config.set_config_defaults()
    wsme_utils.monkeypatch_wsme()
    app = make_app(
        app_conf.pop('root'),
        logging=getattr(config, 'logging', {}),
        **app_conf
    )

    return CORS(app, cfg.CONF)


def init_wsgi():
    m_config.parse_args(args=[])
    return setup_app()
