import pecan
from wsme import types as wtypes
from wsmeext.pecan import wsexpose as expose

from magellan.api.controllers.v1 import job, execution
from magellan.rpc import client


class RootResource(wtypes.Base):
    """Root resource for API version 1.
    It references all other resources belonging to the API.
    """

    uri = wtypes.text


class Controller(object):
    """API root controller for version 1."""

    rpc_client = client.RpcClient()
    jobs = job.JobsController(rpc_client)
    executions = execution.ExecutionsController(rpc_client)

    @expose(RootResource)
    def index(self):
        return RootResource(uri='%s/%s' % (pecan.request.host_url, 'v1'))
