from eventlet import event
from oslo_service import service


class MagellanService(service.Service):
    """Base class for Magellan services.
    The term 'service' here means any Magellan component that can run as
    an independent process.
    """

    def __init__(self):
        super(MagellanService, self).__init__()
        self._started = event.Event()

    def wait_started(self):
        """Wait until the service is fully started."""
        self._started.wait()

    def _notify_started(self):
        self._started.send()

    def start(self):
        super(MagellanService, self).start()

    def stop(self, graceful=False):
        super(MagellanService, self).stop(graceful)
        self._started = event.Event()
