import datetime

from wsme.rest import json as wjson

from magellan.api.controllers.v1 import resources
from magellan.common import consts
from magellan.db import api as db_api
from magellan.tests import base

JOB_DEF = {
    'name': 'my_job1',
    'description': 'empty',
    'method': consts.SCAN_METHOD_SEED_ROUTER,
    'options': {
        "seed_router": "192.168.1.1",
        "snmp": {
            "version": "v2c",
            "community": "private"
        }
    },
    'timeout': 1800,
    'updated_at': None,
    'created_at': datetime.datetime(2017, 12, 1, 15, 0, 0)
}


class TestRestResource(base.SqlAlchemyTest):
    def test_from_dict(self):
        job_def = db_api.job_create(JOB_DEF)

        self.assertIsNotNone(job_def)

        job_def_resource = wjson.fromjson(resources.Job, job_def)

        self.assertIsNotNone(job_def_resource)
